import { Key, LifetimeCollection, Selector } from '../ServiceCollection';
import { IServiceProvider } from './IServiceProvider';
export declare class ServiceProvider<E = any> implements IServiceProvider<E> {
    readonly isDone: boolean;
    readonly depth: number;
    readonly root: ServiceProvider<E>;
    readonly lifetimes: LifetimeCollection<E>;
    readonly instances: Record<Key<any>, any>;
    readonly proxy: E;
    constructor(lifetimes: LifetimeCollection<E>);
    using(action: (provider: E) => any): void;
    provide<T>(selector: Selector<T, E>): T;
}
