"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceProvider = void 0;
var utils_1 = require("../utils");
var ScopedServiceProvider_1 = require("./ScopedServiceProvider");
var ServiceProvider = /** @class */ (function () {
    function ServiceProvider(lifetimes) {
        Object.defineProperty(this, "isDone", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "depth", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
        Object.defineProperty(this, "root", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: this
        });
        Object.defineProperty(this, "lifetimes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "instances", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: {}
        });
        Object.defineProperty(this, "proxy", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.lifetimes = lifetimes;
        this.proxy = (0, utils_1.proxyOf)(this);
    }
    Object.defineProperty(ServiceProvider.prototype, "using", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (action) {
            new ScopedServiceProvider_1.ScopedServiceProvider(this).using(action);
        }
    });
    Object.defineProperty(ServiceProvider.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (selector) {
            return new ScopedServiceProvider_1.ScopedServiceProvider(this).provide(selector);
        }
    });
    return ServiceProvider;
}());
exports.ServiceProvider = ServiceProvider;
